[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.72 and 1.94

version 1.72, 2021/12/11 20:33:50 version 1.94, 2021/12/21 02:16:01
Line 16 
Line 16 
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 set -o errexit -o pipefail -o nounset  set -o errexit -o pipefail -o nounset
   set +o monitor
   export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
 CFILE=SHA256.sig  CFILE=SHA256.sig
 DESTDIR=${DESTDIR:-}  DESTDIR=${DESTDIR:-}
Line 32 
Line 34 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DOWNLOAD=true
   INSTALL=true
 LOCALSRC=  LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have mktemp and a more hostile environment          # we have mktemp and a more hostile environment.
         if [ -x /usr/bin/mktemp ]; then          if [ -x /usr/bin/mktemp ]; then
                 _dir=$( mktemp -d "${1}-XXXXXXXXX" )                  _dir=$( mktemp -d "${1}-XXXXXXXXX" )
         else          else
Line 51 
Line 55 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
   
         # If we're not in the installer, we have su(1)          # If we're not in the installer,
         # and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                 _exit="$?"  
         else          else
                 /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"                      /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                 _exit="$?"  
         fi          fi
           ) & _pid=$!
           set +o monitor
   
           trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
   
           SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
                 echo "Cannot fetch $_src" >&2                  echo "Cannot fetch $_src$_error" >&2
                 return 1                  return 1
         fi          fi
 }  }
Line 81 
Line 114 
 }  }
   
 devices_needing_firmware() {  devices_needing_firmware() {
         local _d _m _grep _dmesgtail _last=''          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
               grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
   
         grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
             while read -r _d _m; do              while read -r _d _m; do
                 _grep="grep"                  [ "$_d" = "$_last" ] && continue
                 [ "$_last" = "$_d" ] && continue                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                 [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "                  [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
                 [ "$_m" = "${_m#^}" ] && _grep="fgrep"  
   
                 echo "$_dmesgtail" | $_grep -q "$_m" || continue                  if [[ $_dmesgtail = *$_m* ]]; then
                 echo "$_d"                          echo "$_d"
                 _last="$_d"                          _last="$_d"
         done                  fi
               done
 }  }
   
 firmware_filename() {  firmware_filename() {
Line 121 
Line 155 
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}"
           local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
         ftp -D "Install" -Vmo- "file:${1}" |          ftp -D "Install" -Vmo- "file:${1}" |
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                  tar -s ",^\+,${_pkgdir}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 172 
Line 207 
 }  }
   
 usage() {  usage() {
         echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
         exit 2          exit 2
 }  }
   
 INSTALL=true  OPT_D=
 DOWNLOAD=true  OPT_L=
   while getopts DL name
 while getopts dL name  
 do  do
        case "$name" in         case "$name" in
        # "download only" means local dir and don't install         D) OPT_D=true ;;
        d) LOCALSRC=. INSTALL=false ;;         L) OPT_L=true ;;
        L) LOCALSRC=. ;;  
        ?) usage 2 ;;         ?) usage 2 ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 # If we're installing from a local dir  [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
 # we don't want to download anything  
 [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false  
 [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"  
   
 set -A devices -- "$@"  if [ "$OPT_D" ]; then
           # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   fi
   
 [ "${devices[*]:-}" ] ||  CFILE="$LOCALSRC/$CFILE"
     set -A devices -- $( devices_needing_firmware )  
   
   if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
   set -A devices -- "$@"
   
 if [ ! "${devices[*]:-}" ]; then  if [ ! "${devices[*]:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo -n "Detecting firmware ..."
         exit          set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
 fi  fi
   
   [ "${devices[*]:-}" ] || exit
   
 if "$DOWNLOAD"; then  if "$DOWNLOAD"; then
         fetch "$CFILE"          fetch "$CFILE"
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
Line 218 
Line 267 
                 f=$( firmware_filename "$d" || true )                  f=$( firmware_filename "$d" || true )
                 [ "$f" ] || continue                  [ "$f" ] || continue
                 f="$LOCALSRC/$f"                  f="$LOCALSRC/$f"
         elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then          elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                 echo "Cannot download local file $f" >&2                  echo "Cannot download local file $f" >&2
                 exit 2                  exit 2
         fi          fi
Line 240 
Line 289 
                         verify "$f" || continue                          verify "$f" || continue
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$INSTALL" && ! "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 echo "Cannot install ${f##*/}, not found" >&2  
                 continue  
         else  
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
         fi          fi
   
         "$INSTALL" || continue          "$INSTALL" || continue

Legend:
Removed from v.1.72  
changed lines
  Added in v.1.94

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>